%define anolis_release 3

%global cpan_version 0.5013
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(.::t/.*.inc\\)
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}

Name:           perl-Math-BigInt-FastCalc
Version:        0.501.300
Release:        %{anolis_release}%{?dist}
Summary:        Math::BigInt::Calc with some XS for more speed
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Math-BigInt-FastCalc
Source0:        https://cpan.metacpan.org/authors/id/P/PJ/PJACKLAM/Math-BigInt-FastCalc-%{cpan_version}.tar.gz

BuildRequires:  coreutils findutils gcc make
BuildRequires:  perl-devel perl-generators perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76 perl(strict) perl(warnings)
BuildRequires:  perl(:VERSION) >= 5.6.1 perl(Carp) perl(Config)
BuildRequires:  perl(Math::BigInt::Calc) >= 1.999801 perl(XSLoader)
BuildRequires:  perl(Math::BigFloat) perl(Math::BigInt) >= 1.999831
BuildRequires:  perl(Test::More) >= 0.88

Conflicts:      perl < 4:5.22.0-348

%description
Math::BigInt::FastCalc is a replacement library for Math::BigInt::Calc that
reimplements some of the Math::BigInt::Calc functions in XS.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness  perl(Math::BigInt) >= 1.999831

%description tests
Tests from %{name}. Execute them with 
"%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n Math-BigInt-FastCalc-%{cpan_version}

rm -r inc
perl -i -ne 'print $_ unless m{^inc/}' MANIFEST
find -type f -exec chmod -x {} +

for F in t/*.t t/Math/BigInt/Lib/TestUtil.pm; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="$RPM_OPT_FLAGS"
%{make_build}

%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -size 0 -delete
%{_fixperms} %{buildroot}/*

mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
rm %{buildroot}%{_libexecdir}/%{name}/t/00sig.t
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'

cd %{_libexecdir}/%{name} && exec prove -I . -r -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
unset TEST_SIGNATURE
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/Math*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc CHANGES CREDITS README TODO

%changelog
* Tue Apr 11 2023 Kaihao Bai <carlo.bai@linux.alibaba.com> - 0.501.300-3
- optimize spec

* Wed Feb 08 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.501.300-2
- remove versioned MODULE_COMPAT_ requires

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.501.300-1
- update to 0.501.300

* Wed Apr 20 2022 zhang xianting <zhangxianting@uniontech.com> - 0.501.200-1
- Initial build for Anolis V23
